> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Create ScratchFile

POST https://{tenant_name}.benchling.com/api/v3/scratch-file
Content-Type: application/json

Create ScratchFile.

Reference: https://docs.benchling.com/docs/api/benchling-api/scratch-file/create

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Headers

- `EARLY-ACCESS` (string, optional) — Set to true to access beta operations via /api/v3.

### Body (application/json)

This endpoint expects a CreateScratchFileInput.

- `filename` (string, required)
- `name` (string, optional)

## Response

### 201

Created

- `__typename` (string, optional)
- `createdAt` (string, optional, nullable)
- `creator` (PrincipalRef, optional)
- `downloadUrl` (string, optional, nullable)
- `errorMessage` (string, optional, nullable)
- `externalFileId` (string, optional, nullable)
- `file` (FileRef, optional, nullable)
- `filename` (string, optional)
- `id` (string, optional)
- `mimeType` (string, optional, nullable)
- `modifiedAt` (string, optional, nullable)
- `name` (string, optional)
- `originAutomationStepData` (AutomationStepDataRef, optional, nullable) — The automation step data that produced this file.
- `size` (integer, optional, nullable)
- `uploadStatus` (enum, optional)
  - Allowed values: `SUCCEEDED`, `FAILED_VALIDATION`, `IN_PROGRESS`, `NOT_UPLOADED`
- `uploadUrl` (string, optional, nullable)
- `originPipelineStepData` (AutomationStepDataRef, optional, nullable, deprecated) — Use originAutomationStepData instead.

## Errors

### 400 Scratch File Create Request Bad Request Error

Bad Request

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 403 Scratch File Create Request Forbidden Error

Forbidden

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 404 Scratch File Create Request Not Found Error

Not Found

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 409 Scratch File Create Request Conflict Error

Conflict

- `detail` (GeneralErrorDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)

### 429 Scratch File Create Request Too Many Requests Error

Too Many Requests

- `detail` (TooManyRequestsErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `invalidId` (string, optional)
- `violated-policies` (list of enum, optional) — The budget policies that rejected the request, in canonical order: `user`, `integration`, then `tenant`.
  - Allowed values: `user`, `integration`, `tenant`

### 500 Scratch File Create Request Internal Server Error

Internal Server Error

- `detail` (InternalServerErrorBodyDetail, required, nullable)
- `instance` (string, required)
- `status` (integer, required)
- `title` (string, required, nullable)
- `type` (string, required)
- `errorId` (string, optional)

## Types

### PrincipalRef

- `__typename` (string, optional)
- `id` (string, optional)

### FileRef

- `__typename` (string, optional)
- `id` (string, optional)

### AutomationStepDataRef

- `__typename` (string, optional)
- `id` (string, optional)

### GeneralErrorDetail

### TooManyRequestsErrorBodyDetail

### InternalServerErrorBodyDetail

## Examples

**Request**

```json
{
  "filename": "filename"
}
```

**Response**

```json
{
  "__typename": "__typename",
  "createdAt": "createdAt",
  "creator": {
    "__typename": "__typename",
    "id": "id"
  },
  "downloadUrl": "downloadUrl",
  "errorMessage": "errorMessage",
  "externalFileId": "externalFileId",
  "file": {
    "__typename": "__typename",
    "id": "id"
  },
  "filename": "filename",
  "id": "id",
  "mimeType": "mimeType",
  "modifiedAt": "modifiedAt",
  "name": "name",
  "originAutomationStepData": {
    "__typename": "__typename",
    "id": "id"
  },
  "size": 1,
  "uploadStatus": "SUCCEEDED",
  "uploadUrl": "uploadUrl",
  "originPipelineStepData": {
    "__typename": "__typename",
    "id": "id"
  }
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v3/scratch-file"

payload = { "filename": "filename" }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v3/scratch-file';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"filename":"filename"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```